// Class: openfl._internal.renderer.opengl.GLShaderManager

var $global = typeof window != "undefined" ? window : typeof global != "undefined" ? global : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = require("./../../../../hxClasses_stub").default;
var $import = require("./../../../../import_stub").default;
var $extend = require("./../../../../extend_stub").default;
function openfl__$internal_renderer_AbstractShaderManager() {return require("./../../../../openfl/_internal/renderer/AbstractShaderManager");}
function openfl_display_DisplayObjectShader() {return require("./../../../../openfl/display/DisplayObjectShader");}
function openfl_display_GraphicsShader() {return require("./../../../../openfl/display/GraphicsShader");}

// Constructor

var GLShaderManager = function(gl) {
	(openfl__$internal_renderer_AbstractShaderManager().default).call(this);
	this.gl = gl;
	this.defaultDisplayShader = new (openfl_display_DisplayObjectShader().default)();
	this.defaultGraphicsShader = new (openfl_display_GraphicsShader().default)();
	this.defaultShader = this.defaultDisplayShader;
	this.initShader(this.defaultShader);
}

// Meta

GLShaderManager.__name__ = ["openfl","_internal","renderer","opengl","GLShaderManager"];
GLShaderManager.__super__ = (openfl__$internal_renderer_AbstractShaderManager().default);
GLShaderManager.prototype = $extend((openfl__$internal_renderer_AbstractShaderManager().default).prototype, {
	applyAlpha: function(alpha) {
		if(this.currentGraphicsShader != null) {
			if(this.currentGraphicsShader.get_data().alpha.value == null) {
				this.currentGraphicsShader.get_data().alpha.value = [];
			}
			this.currentGraphicsShader.get_data().alpha.value[0] = alpha;
		} else {
			if(this.currentDisplayShader.get_data().alpha.value == null) {
				this.currentDisplayShader.get_data().alpha.value = [];
			}
			this.currentDisplayShader.get_data().alpha.value[0] = alpha;
		}
	},
	applyBitmap: function(bitmapData,smoothing,matrix,alpha,colorTransform) {
		this.applyBitmapData(bitmapData,smoothing);
		this.applyMatrix(matrix);
		this.applyAlpha(alpha);
		this.applyColorTransform(colorTransform);
	},
	applyBitmapData: function(bitmapData,smoothing) {
		if(this.currentGraphicsShader != null) {
			this.currentGraphicsShader.get_data().texture0.input = bitmapData;
			this.currentGraphicsShader.get_data().texture0.smoothing = smoothing;
		} else {
			this.currentDisplayShader.get_data().texture0.input = bitmapData;
			this.currentDisplayShader.get_data().texture0.smoothing = smoothing;
		}
	},
	applyColor: function(alpha,colorTransform) {
		this.applyAlpha(alpha);
		this.applyColorTransform(colorTransform);
	},
	applyColorTransform: function(colorTransform) {
		var useColorTransform = colorTransform != null && !colorTransform.__isDefault();
		if(this.currentGraphicsShader != null) {
			var shaderData = this.currentGraphicsShader.get_data();
			if(shaderData.openfl_HasColorTransform.value == null) {
				shaderData.openfl_HasColorTransform.value = [];
			}
			shaderData.openfl_HasColorTransform.value[0] = useColorTransform;
			if(useColorTransform) {
				colorTransform.__setArrays(GLShaderManager.colorMultipliers,GLShaderManager.colorOffsets);
				shaderData.colorMultipliers.value = GLShaderManager.colorMultipliers;
				shaderData.colorOffsets.value = GLShaderManager.colorOffsets;
			} else {
				shaderData.colorMultipliers.value = GLShaderManager.emptyColor;
				shaderData.colorOffsets.value = GLShaderManager.emptyColor;
			}
		} else {
			var shaderData1 = this.currentDisplayShader.get_data();
			if(shaderData1.openfl_HasColorTransform.value == null) {
				shaderData1.openfl_HasColorTransform.value = [];
			}
			shaderData1.openfl_HasColorTransform.value[0] = useColorTransform;
			if(useColorTransform) {
				colorTransform.__setArrays(GLShaderManager.colorMultipliers,GLShaderManager.colorOffsets);
				shaderData1.colorMultipliers.value = GLShaderManager.colorMultipliers;
				shaderData1.colorOffsets.value = GLShaderManager.colorOffsets;
			} else {
				shaderData1.colorMultipliers.value = GLShaderManager.emptyColor;
				shaderData1.colorOffsets.value = GLShaderManager.emptyColor;
			}
		}
	},
	applyDefaultColor: function() {
		if(this.currentShaderBuffer != null) {
			var hasAlpha = false;
			var hasMultipliers = false;
			var floatIndex = 0;
			var _g1 = 0;
			var _g = this.currentShaderBuffer.paramCount;
			while(_g1 < _g) {
				var i = _g1++;
				if(this.currentShaderBuffer.paramTypes[i] == 1) {
					if(this.currentShaderBuffer.paramRefs_Float[floatIndex].name == "openfl_HasColorMultipliers") {
						hasMultipliers = this.currentShaderBuffer.paramLengths[i] > 0;
					} else if(this.currentShaderBuffer.paramRefs_Float[floatIndex].name == "alpha") {
						hasAlpha = this.currentShaderBuffer.paramLengths[i] > 0;
					}
					++floatIndex;
				}
			}
			GLShaderManager.useColorTransform[0] = hasMultipliers ? 1 : 0;
			this.currentShaderBuffer.addOverride("openfl_HasColorTransform",GLShaderManager.useColorTransform);
			if(!hasAlpha) {
				this.currentShaderBuffer.addOverride("alpha",GLShaderManager.emptyAlpha);
			}
		} else if(this.currentGraphicsShader != null) {
			var useColorTransform = this.currentGraphicsShader.get_data().colorMultipliers.value != null;
			if(this.currentGraphicsShader.get_data().openfl_HasColorTransform.value == null) {
				this.currentGraphicsShader.get_data().openfl_HasColorTransform.value = [];
			}
			this.currentGraphicsShader.get_data().openfl_HasColorTransform.value[0] = useColorTransform;
		} else if(this.currentDisplayShader != null) {
			var useColorTransform1 = this.currentDisplayShader.get_data().colorMultipliers.value != null;
			if(this.currentDisplayShader.get_data().openfl_HasColorTransform.value == null) {
				this.currentDisplayShader.get_data().openfl_HasColorTransform.value = [];
			}
			this.currentDisplayShader.get_data().openfl_HasColorTransform.value[0] = useColorTransform1;
		}
	},
	applyMatrix: function(matrix) {
		if(this.currentShaderBuffer != null) {
			this.currentShaderBuffer.addOverride("openfl_Matrix",matrix);
		} else if(this.currentGraphicsShader != null) {
			this.currentGraphicsShader.get_data().openfl_Matrix.value = matrix;
		} else if(this.currentDisplayShader != null) {
			this.currentDisplayShader.get_data().openfl_Matrix.value = matrix;
		}
	},
	initShader: function(shader) {
		if(shader != null) {
			if(shader.gl == null) {
				shader.gl = this.gl;
				shader.__init();
			}
			return shader;
		}
		return this.defaultShader;
	},
	initDisplayShader: function(shader) {
		if(shader != null) {
			if(shader.gl == null) {
				shader.gl = this.gl;
				shader.__init();
			}
			return shader;
		}
		return this.defaultDisplayShader;
	},
	initGraphicsShader: function(shader) {
		if(shader != null) {
			if(shader.gl == null) {
				shader.gl = this.gl;
				shader.__init();
			}
			return shader;
		}
		return this.defaultGraphicsShader;
	},
	initShaderBuffer: function(shaderBuffer) {
		if(shaderBuffer != null) {
			return this.initGraphicsShader(shaderBuffer.shader);
		}
		return this.defaultGraphicsShader;
	},
	setShader: function(shader,graphics) {
		if(this.currentShader == shader) {
			return;
		}
		this.currentDisplayShader = null;
		this.currentGraphicsShader = null;
		if(this.currentShader != null) {
			this.currentShader.__disable();
			this.currentShaderBuffer = null;
		}
		if(shader == null) {
			this.currentShader = null;
			this.gl.useProgram(null);
			return;
		} else {
			this.currentShader = shader;
			if(graphics) {
				this.currentGraphicsShader = shader;
			} else {
				this.currentDisplayShader = shader;
			}
			this.initShader(shader);
			this.gl.useProgram(shader.glProgram);
			this.currentShader.__enable();
		}
	},
	setShaderBuffer: function(shaderBuffer) {
		this.setShader(shaderBuffer.shader,true);
		this.currentShaderBuffer = shaderBuffer;
	},
	updateShader: function() {
		if(this.currentShader != null) {
			this.currentShader.__update();
		}
	},
	updateShaderBuffer: function() {
		if(this.currentShader != null && this.currentShaderBuffer != null) {
			this.currentShader.__updateFromBuffer(this.currentShaderBuffer);
		}
	}
});
GLShaderManager.prototype.__class__ = $hxClasses["openfl._internal.renderer.opengl.GLShaderManager"] = GLShaderManager;

// Init



// Statics


GLShaderManager.emptyAlpha = [1.]
GLShaderManager.colorMultipliers = [0,0,0,0.]
GLShaderManager.colorOffsets = [0,0,0,0.]
GLShaderManager.emptyColor = [0,0,0,0.]
GLShaderManager.useColorTransform = [0]

// Export

exports.default = GLShaderManager;